                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*            concurrency            */
                     /*-----------------------------------*/

#include <pthread.h>
#include <libkern/OSAtomic.h>

#include "SlipMemory.h"

/*-------------------------------- public types ------------------------------*/

typedef  pthread_cond_t CND_type;
typedef pthread_mutex_t MTX_type;
typedef      OSSpinLock SPL_type;
typedef       pthread_t PTH_type;

typedef CND_type * CRF_type;
typedef MTX_type * MRF_type;
typedef PTH_type * PRF_type;
typedef SPL_type * SRF_type;

typedef ADR_type (* WRK_type)(ADR_type);

/*------------------------------ public prototypes ---------------------------*/

NIL_type Concurrency_Initialize_Conditional(CRF_type);
NIL_type       Concurrency_Wait_Conditional(CRF_type,
                                            MRF_type);
NIL_type  Concurrency_Broadcast_Conditional(CRF_type);

NIL_type                 Concurrency_Cancel(PTH_type);
NIL_type                Concurrency_Pthread(PRF_type,
                                            WRK_type,
                                            ADR_type);
NIL_type                   Concurrency_Join(PTH_type);
NIL_type                   Concurrency_Kill(NIL_type);
PTH_type                   Concurrency_Self(NIL_type);

NIL_type       Concurrency_Initialize_Mutex(MRF_type);
NIL_type             Concurrency_Mutex_Lock(MRF_type); 
NIL_type           Concurrency_Mutex_Unlock(MRF_type);

NIL_type        Concurrency_Initialize_Spin(SRF_type);
NIL_type              Concurrency_Spin_Lock(SRF_type); 
NIL_type            Concurrency_Spin_Unlock(SRF_type);

NIL_type              Concurrency_Increment(REF_type);
NIL_type              Concurrency_Decrement(REF_type);

UNS_type                    Concurrency_Add(REF_type,
                                            UNS_type);
UNS_type               Concurrency_Subtract(REF_type,
                                            UNS_type);

/*----------------------------------------------------------------------------*/
                           
NIL_type             Concurrency_Initialize(NIL_type);
