                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*              context              */
                     /*-----------------------------------*/

/*------------------------------ public constants ----------------------------*/

const static CID_type Context_Main_Id = 1;

/*-------------------------------- public types ------------------------------*/

typedef NIL_type (* TPR_type) (CID_type);

/*------------------------------ Memory management----------------------------*/

NIL_type             Context_Collect_C(NIL_type);
PTR_type            Context_Make_Chunk(BYT_type,
                                       UNS_type);
NIL_type            Context_Make_Claim(UNS_type);
NIL_type     Context_Memory_Initialize(NIL_type);
NIL_type         Context_Release_Claim(UNS_type);

/*------------------------------ Context management---------------------------*/

NIL_type                 Context_Flush(NIL_type);
EXP_type        Context_Get_Expression(CID_type);
EXP_type               Context_Restore(CID_type);    
NIL_type                  Context_Save(CID_type,
                                       EXP_type);    
NIL_type        Context_Set_Expression(CID_type,
                                       EXP_type);
                                       
/*----------------------------- Fork/Join management--------------------------*/

TXT_type                  Context_Read(TXT_type);
CID_type          Context_Spawn_Task_C(CID_type,
                                       SPR_type);
NIL_type            Context_Start_Task(NIL_type);
NIL_type             Context_Stop_Task(NIL_type);
EXP_type             Context_Sync_Task(CID_type);

/*---------------------------- Environment management ------------------------*/

NIL_type Context_Adjust_Global_Frame_C(UNS_type);
ENV_type    Context_Environment_Grow_C(CID_type);
NIL_type   Context_Environment_Replace(CID_type,
                                       ENV_type,
                                       FRM_type);
ENV_type       Context_Get_Environment(CID_type);
FRM_type             Context_Get_Frame(CID_type);
NIL_type      Context_Global_Frame_Set(EXP_type,
                                       UNS_type);
NIL_type            Context_Global_Get(CID_type,
                                       NBR_type,
                                       NBR_type);
NIL_type            Context_Global_Set(CID_type,
                                       NBR_type,
                                       NBR_type);
NIL_type             Context_Local_Get(CID_type,
                                       NBR_type);
NIL_type             Context_Local_Set(CID_type,
                                       NBR_type);
FRM_type          Context_Make_Frame_C(CID_type,
                                       UNS_type);
FRM_type            Context_Mark_Frame(CID_type);
NIL_type Context_Release_Current_Frame(CID_type);
NIL_type         Context_Release_Frame(CID_type,
                                       VEC_type);
NIL_type     Context_Reset_Environment(CID_type);

/*------------------------------- Thread management---------------------------*/

THR_type           Context_Mark_Thread(CID_type);
THR_type         Context_Thread_Keep_C(CID_type);
THR_type        Context_Thread_Patch_C(CID_type,
                                       NBR_type);
THR_type           Context_Thread_Peek(CID_type);
THR_type         Context_Thread_Poke_C(CID_type,
                                       NBR_type,
                                       EXP_type,
                                       UNS_type);
THR_type         Context_Thread_Push_C(CID_type,
                                       NBR_type,
                                       EXP_type,
                                       UNS_type);
NIL_type        Context_Thread_Replace(CID_type,
                                       THR_type);
NIL_type            Context_Thread_Zap(CID_type);

/*---------------------- Thread procedure table management--------------------*/

NIL_type               Context_Proceed(CID_type);
NBR_type              Context_Register(TPR_type,
                                       UNS_type);

/*----------------------------------------------------------------------------*/

NIL_type          Context_Initialize_M(NIL_type);              
