                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*               grammar             */
                     /*-----------------------------------*/

#include "SlipConcurrency.h"

/*------------------------------- public macros ------------------------------*/

#define Define_Grammar_Frame(SIGNATURE)                                        \
  typedef struct SIGNATURE * SIGNATURE##_type
  
#define Begin_Grammar_Frame(SIGNATURE)                                         \
  typedef struct SIGNATURE {                                                   \
  Define_Grammar_Slot(CEL, hdr)

#define Define_Grammar_Slot(SIGNATURE, Name)                                   \
  SIGNATURE##_type Name
  
#define End_Grammar_Frame(SIGNATURE)                                           \
  } SIGNATURE;                                                                 \
                                                                               \
static const UNS_type SIGNATURE##_size                                         \
                      = (sizeof(SIGNATURE)/sizeof(CEL_type) - 1)

/*-------------------------------- public types ------------------------------*/

typedef enum { APL_tag = 0x00<<1 | 0x0,            /* 00 */
               BEG_tag = 0x01<<1 | 0x0,            /* 02 */
               CNT_tag = 0x02<<1 | 0x0,            /* 04 */
               DFF_tag = 0x03<<1 | 0x0,            /* 06 */
               DFV_tag = 0x04<<1 | 0x0,            /* 08 */
               DFZ_tag = 0x05<<1 | 0x0,            /* 10 */
               GLB_tag = 0x06<<1 | 0x0,            /* 12 */
               IFF_tag = 0x07<<1 | 0x0,            /* 14 */
               IFZ_tag = 0x08<<1 | 0x0,            /* 16 */
               LCL_tag = 0x09<<1 | 0x0,            /* 18 */
               LMB_tag = 0x0A<<1 | 0x0,            /* 20 */
               LMZ_tag = 0x0B<<1 | 0x0,            /* 22 */
               MRK_tag = 0x0C<<1 | 0x0,            /* 24 */
               PAI_tag = 0x0D<<1 | 0x0,            /* 26 */
               PRC_tag = 0x0E<<1 | 0x0,            /* 28 */
               PRT_tag = 0x0F<<1 | 0x0,            /* 30 */
               PRZ_tag = 0x10<<1 | 0x0,            /* 32 */
               QUO_tag = 0x11<<1 | 0x0,            /* 34 */
               SEQ_tag = 0x12<<1 | 0x0,            /* 36 */
               SPN_tag = 0x13<<1 | 0x0,            /* 38 */
               STG_tag = 0x14<<1 | 0x0,            /* 40 */
               STL_tag = 0x15<<1 | 0x0,            /* 42 */
               THK_tag = 0x16<<1 | 0x0,            /* 44 */
               VAL_tag = 0x17<<1 | 0x0,            /* 46 */
               VEC_tag = 0x18<<1 | 0x0,            /* 48 */
               WHI_tag = 0x19<<1 | 0x0,            /* 50 */

               CHA_tag = 0x00<<1 | 0x1,            /* 01 */
               FLS_tag = 0x01<<1 | 0x1,            /* 03 */
               LCK_tag = 0x02<<1 | 0x1,            /* 05 */
               NAT_tag = 0x03<<1 | 0x1,            /* 07 */
               NUL_tag = 0x04<<1 | 0x1,            /* 09 */
               NBR_tag = 0x05<<1 | 0x1,            /* 11 */
               PRM_tag = 0x06<<1 | 0x1,            /* 13 */
               REA_tag = 0x07<<1 | 0x1,            /* 15 */
               STR_tag = 0x08<<1 | 0x1,            /* 17 */
               SYM_tag = 0x09<<1 | 0x1,            /* 19 */
               TRU_tag = 0x0A<<1 | 0x1,            /* 21 */
               TSK_tag = 0x0B<<1 | 0x1,            /* 23 */
               USP_tag = 0x0C<<1 | 0x1 } TAG_type; /* 25 */

Define_Grammar_Frame(APL);
Define_Grammar_Frame(BEG);
Define_Grammar_Frame(CHA);
Define_Grammar_Frame(CNT);
Define_Grammar_Frame(DFF);
Define_Grammar_Frame(DFV);
Define_Grammar_Frame(ENV);   /* opaque */
Define_Grammar_Frame(GLB);
Define_Grammar_Frame(IFF);
Define_Grammar_Frame(IFZ);
Define_Grammar_Frame(LCK);
Define_Grammar_Frame(LCL);
Define_Grammar_Frame(LMB);
Define_Grammar_Frame(NAT);
Define_Grammar_Frame(PAI);
Define_Grammar_Frame(QUO);
Define_Grammar_Frame(PRC);
Define_Grammar_Frame(PRM);
Define_Grammar_Frame(PRT);
Define_Grammar_Frame(REA);
Define_Grammar_Frame(SPN);
Define_Grammar_Frame(STG);
Define_Grammar_Frame(STL);
Define_Grammar_Frame(STR);
Define_Grammar_Frame(SYM);
Define_Grammar_Frame(THK);
Define_Grammar_Frame(THR);   /* opaque */
Define_Grammar_Frame(TSK);
Define_Grammar_Frame(VAL);
Define_Grammar_Frame(WHI);

typedef UNS_type   CID_type;

typedef NIL_type * EXP_type;
typedef EXP_type * FRM_type; /* opaque */
typedef EXP_type * SEQ_type;
typedef EXP_type * VEC_type;

typedef EXP_type   FLS_type;
typedef EXP_type   NBR_type;
typedef EXP_type   NUL_type;
typedef EXP_type   TRU_type;
typedef EXP_type   USP_type;

typedef EXP_type * ERF_type;
typedef FRM_type * FRF_type;
typedef VEC_type * VRF_type;

typedef NIL_type (* NPR_type) (CID_type,
                               EXP_type);
typedef EXP_type (* SPR_type) (CID_type);

/*------------------------------ public variables ----------------------------*/

extern VEC_type Grammar_Empty_Vector;
extern FLS_type Grammar_False;
extern NUL_type Grammar_Null;
extern NBR_type Grammar_One;
extern TRU_type Grammar_True;
extern USP_type Grammar_Unspecified;
extern NBR_type Grammar_Zero;

/*------------------------------ public prototypes ---------------------------*/

TAG_type Grammar_Tag(EXP_type);

/*------------------------------ APL declarations ----------------------------*/

Begin_Grammar_Frame(APL);
  Define_Grammar_Slot(EXP, exp);
  Define_Grammar_Slot(VEC, opd);
End_Grammar_Frame(APL);

BYT_type      is_APL(EXP_type);
APL_type  make_APL_M(EXP_type,
                     VEC_type);

/*------------------------------ BEG declarations ----------------------------*/

Begin_Grammar_Frame(BEG);
  Define_Grammar_Slot(EXP, bod);
End_Grammar_Frame(BEG);

BYT_type      is_BEG(EXP_type);
BEG_type  make_BEG_M(EXP_type);

/*------------------------------ CHA declarations ----------------------------*/

Begin_Grammar_Frame(CHA);
  Define_Grammar_Slot(CHR, chr);
End_Grammar_Frame(CHA);

BYT_type      is_CHA(EXP_type);
CHA_type  make_CHA_M(CHR_type);

/*------------------------------ CNT declarations ----------------------------*/

Begin_Grammar_Frame(CNT);
  Define_Grammar_Slot(ENV, env);
  Define_Grammar_Slot(FRM, frm);
  Define_Grammar_Slot(THR, thr);
End_Grammar_Frame(CNT);

BYT_type      is_CNT(EXP_type);
CNT_type  make_CNT_M(ENV_type,
                     FRM_type,
                     THR_type);
                  
/*------------------------------ DFF declarations ----------------------------*/

Begin_Grammar_Frame(DFF);
  Define_Grammar_Slot(SYM, nam);
  Define_Grammar_Slot(NBR, ofs);
  Define_Grammar_Slot(NBR, par);
  Define_Grammar_Slot(NBR, siz);
  Define_Grammar_Slot(EXP, bod);
End_Grammar_Frame(DFF);

BYT_type      is_DFF(EXP_type);
BYT_type      is_DFZ(EXP_type);
DFF_type  make_DFF_M(SYM_type,
                     NBR_type,
                     NBR_type,
                     NBR_type,
                     EXP_type);
DFF_type  make_DFZ_M(SYM_type,
                     NBR_type,
                     NBR_type,
                     NBR_type,
                     EXP_type);
                  
/*------------------------------ DFV declarations ----------------------------*/

Begin_Grammar_Frame(DFV);
  Define_Grammar_Slot(NBR, ofs);
  Define_Grammar_Slot(EXP, exp);
End_Grammar_Frame(DFV);

BYT_type      is_DFV(EXP_type);
DFV_type  make_DFV_M(NBR_type,
                     EXP_type);

/*------------------------------ FLS declarations ----------------------------*/

BYT_type      is_FLS(EXP_type);
FLS_type    make_FLS(NIL_type);

/*------------------------------ GLB declarations ----------------------------*/

Begin_Grammar_Frame(GLB);
  Define_Grammar_Slot(NBR, scp);
  Define_Grammar_Slot(NBR, ofs);
End_Grammar_Frame(GLB);

BYT_type      is_GLB(EXP_type);
GLB_type  make_GLB_M(NBR_type,
                     NBR_type);

/*------------------------------ IFF declarations ----------------------------*/

Begin_Grammar_Frame(IFF);
  Define_Grammar_Slot(EXP, prd);
  Define_Grammar_Slot(EXP, cns);
  Define_Grammar_Slot(EXP, alt);
End_Grammar_Frame(IFF);

BYT_type      is_IFF(EXP_type);
IFF_type   make_IFF_M(EXP_type,
                     EXP_type,
                     EXP_type);

/*------------------------------ IFZ declarations ----------------------------*/

Begin_Grammar_Frame(IFZ);
  Define_Grammar_Slot(EXP, prd);
  Define_Grammar_Slot(EXP, cns);
End_Grammar_Frame(IFZ);

BYT_type      is_IFZ(EXP_type);
IFZ_type  make_IFZ_M(EXP_type,
                     EXP_type);

/*------------------------------ LCK declarations ----------------------------*/

Begin_Grammar_Frame(LCK);
  Define_Grammar_Slot(MTX, mtx);
End_Grammar_Frame(LCK);

BYT_type      is_LCK(EXP_type);
LCK_type  make_LCK_M(MTX_type);

/*------------------------------ LCL declarations ----------------------------*/

Begin_Grammar_Frame(LCL);
  Define_Grammar_Slot(NBR, ofs);
End_Grammar_Frame(LCL);

BYT_type      is_LCL(EXP_type);
LCL_type  make_LCL_M(NBR_type);

/*------------------------------ LMB declarations ----------------------------*/

Begin_Grammar_Frame(LMB);
  Define_Grammar_Slot(NBR, par);
  Define_Grammar_Slot(NBR, siz);
  Define_Grammar_Slot(EXP, bod);
End_Grammar_Frame(LMB);

BYT_type      is_LMB(EXP_type);
BYT_type      is_LMZ(EXP_type);
LMB_type  make_LMB_M(NBR_type,
                     NBR_type,
                     EXP_type);
LMB_type  make_LMZ_M(NBR_type,
                     NBR_type,
                     EXP_type);

/*------------------------------ MRK declarations ----------------------------*/

BYT_type      is_MRK(EXP_type);
NIL_type   apply_MRK(EXP_type);

/*------------------------------ NAT declarations ----------------------------*/

Begin_Grammar_Frame(NAT);
  Define_Grammar_Slot(NPR, npr);
  Define_Grammar_Slot(CHR, nam[]);
End_Grammar_Frame(NAT);

BYT_type      is_NAT(EXP_type);
NAT_type  make_NAT_M(NPR_type,
                     TXT_type);

/*------------------------------ NBR declarations ----------------------------*/

BYT_type      is_NBR(EXP_type);
NBR_type    make_NBR(SGN_type);
SGN_type     get_NBR(NBR_type);

/*------------------------------ NUL declarations ----------------------------*/

BYT_type      is_NUL(EXP_type);
NUL_type    make_NUL(NIL_type);

/*------------------------------ PAI declarations ----------------------------*/

Begin_Grammar_Frame(PAI);
  Define_Grammar_Slot(EXP, car);
  Define_Grammar_Slot(EXP, cdr);
End_Grammar_Frame(PAI);

BYT_type      is_PAI(EXP_type);
PAI_type  make_PAI_M(EXP_type,
                     EXP_type);

/*------------------------------ PRC declarations ----------------------------*/

Begin_Grammar_Frame(PRC);
  Define_Grammar_Slot(SYM, nam);
  Define_Grammar_Slot(NBR, par);
  Define_Grammar_Slot(NBR, siz);
  Define_Grammar_Slot(EXP, bod);
  Define_Grammar_Slot(ENV, env);
End_Grammar_Frame(PRC);

BYT_type      is_PRC(EXP_type);
BYT_type      is_PRZ(EXP_type);
PRC_type  make_PRC_M(SYM_type,
                     NBR_type,
                     NBR_type,
                     EXP_type,
                     ENV_type);
PRC_type  make_PRZ_M(SYM_type,
                     NBR_type,
                     NBR_type,
                     EXP_type,
                     ENV_type);

/*------------------------------ PRM declarations ----------------------------*/

Begin_Grammar_Frame(PRM);
  Define_Grammar_Slot(CID, cid);
End_Grammar_Frame(PRM);

BYT_type      is_PRM(EXP_type);
PRM_type  make_PRM_M(UNS_type);

/*------------------------------ PRT declarations ----------------------------*/

Begin_Grammar_Frame(PRT);
  Define_Grammar_Slot(EXP, bod);
  Define_Grammar_Slot(LCK, lck);
End_Grammar_Frame(PRT);

BYT_type      is_PRT(EXP_type);
PRT_type  make_PRT_M(EXP_type,
                     LCK_type);

/*------------------------------ QUO declarations ----------------------------*/

Begin_Grammar_Frame(QUO);
  Define_Grammar_Slot(EXP, exp);
End_Grammar_Frame(QUO);

BYT_type      is_QUO(EXP_type);
QUO_type  make_QUO_M(EXP_type);

/*------------------------------ REA declarations ----------------------------*/

Begin_Grammar_Frame(REA);
  Define_Grammar_Slot(FLO, flo);
End_Grammar_Frame(REA);

BYT_type      is_REA(EXP_type);
REA_type  make_REA_M(FLO_type);

/*------------------------------ SEQ declarations ----------------------------*/

BYT_type      is_SEQ(EXP_type);
SEQ_type  make_SEQ_M(UNS_type);
UNS_type    size_SEQ(VEC_type);

/*------------------------------ SPN declarations ----------------------------*/

Begin_Grammar_Frame(SPN);
  Define_Grammar_Slot(EXP, exp);
End_Grammar_Frame(SPN);

BYT_type      is_SPN(EXP_type);
SPN_type  make_SPN_M(EXP_type);

/*------------------------------ STG declarations ----------------------------*/

Begin_Grammar_Frame(STG);
  Define_Grammar_Slot(NBR, scp);
  Define_Grammar_Slot(NBR, ofs);
  Define_Grammar_Slot(EXP, exp);
End_Grammar_Frame(STG);

BYT_type      is_STG(EXP_type);
STG_type  make_STG_M(NBR_type,
                     NBR_type,
                     EXP_type);

/*------------------------------ STL declarations ----------------------------*/

Begin_Grammar_Frame(STL);
  Define_Grammar_Slot(NBR, ofs);
  Define_Grammar_Slot(EXP, exp);
End_Grammar_Frame(STL);

BYT_type      is_STL(EXP_type);
STL_type  make_STL_M(NBR_type,
                     EXP_type);

/*------------------------------ STR declarations ----------------------------*/

Begin_Grammar_Frame(STR);
  Define_Grammar_Slot(CHR, txt[]);
End_Grammar_Frame(STR);

BYT_type      is_STR(EXP_type);
STR_type  make_STR_M(TXT_type);
UNS_type    size_STR(TXT_type);

/*------------------------------ SYM declarations ----------------------------*/

Begin_Grammar_Frame(SYM);
  Define_Grammar_Slot(CHR, txt[]);
End_Grammar_Frame(SYM);

BYT_type      is_SYM(EXP_type);
SYM_type  make_SYM_M(TXT_type);
UNS_type    size_SYM(TXT_type);

/*------------------------------ THK declarations ----------------------------*/

Begin_Grammar_Frame(THK);
  Define_Grammar_Slot(EXP, bod);
  Define_Grammar_Slot(NBR, siz);
End_Grammar_Frame(THK);

BYT_type      is_THK(EXP_type);
THK_type  make_THK_M(EXP_type,
                     NBR_type);

/*------------------------------ TRU declarations ----------------------------*/

BYT_type      is_TRU(EXP_type);
TRU_type    make_TRU(NIL_type);

/*------------------------------ TSK declarations ----------------------------*/

Begin_Grammar_Frame(TSK);
  Define_Grammar_Slot(PTH, pth);
End_Grammar_Frame(TSK);

BYT_type      is_TSK(EXP_type);
TSK_type  make_TSK_M(PTH_type);
UNS_type    size_TSK(NIL_type);
                  
/*------------------------------ USP declarations ----------------------------*/

BYT_type      is_USP(EXP_type);
USP_type    make_USP(NIL_type);

/*------------------------------ VAL declarations ----------------------------*/

Begin_Grammar_Frame(VAL);
  Define_Grammar_Slot(EXP, exp);
End_Grammar_Frame(VAL);

BYT_type      is_VAL(EXP_type);
VAL_type convert_VAL(PRM_type,
                     EXP_type);
                  
/*------------------------------ VEC declarations ----------------------------*/

BYT_type      is_VEC(EXP_type);
VEC_type  make_VEC_M(UNS_type);
UNS_type    size_VEC(VEC_type);

/*------------------------------ WHI declarations ----------------------------*/

Begin_Grammar_Frame(WHI);
  Define_Grammar_Slot(EXP, prd);
  Define_Grammar_Slot(EXP, bod);
End_Grammar_Frame(WHI);

BYT_type      is_WHI(EXP_type);
WHI_type  make_WHI_M(EXP_type,
                     EXP_type);
/*----------------------------------------------------------------------------*/
                               
NIL_type Grammar_Initialize(NIL_type);