                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*               main                */
                     /*-----------------------------------*/

#include "SlipGrammar.h"
        
/*------------------------------- public macros ------------------------------*/

#define Main_Claim_Default()                                                   \
  Context_Make_Claim(Main_Default_Margin)

#define Main_Claim_Dynamic(SIZE)                                               \
  Context_Make_Claim(SIZE + 1)

#define Main_Register(VARIABLE)                                                \
  _Main_Register((ERF_type)&VARIABLE);

#define Main_Release_Default()                                                 \
  Context_Release_Claim(Main_Default_Margin)

#define Main_Release_Dynamic(SIZE)                                             \
  Context_Release_Claim(SIZE + 1)

/*------------------------------ public constants ----------------------------*/

enum { Main_Buffer_Size    = 256,
       Main_Default_Margin =  20,
       Main_Maximum_Number = Memory_Immediate_Maximum };

static const TXT_type Main_Anonymous_String   = "anonymous";
static const TXT_type Main_Application_String = "application";
static const TXT_type Main_Begin_String       = "begin";
static const TXT_type Main_Define_String      = "define";
static const TXT_type Main_If_String          = "if";
static const TXT_type Main_Lambda_String      = "lambda";
static const TXT_type Main_Protect_String     = "protect";
static const TXT_type Main_Quote_String       = "quote";
static const TXT_type Main_Set_String         = "set!";
static const TXT_type Main_Spawn_String       = "spawn";
static const TXT_type Main_While_String       = "while";

/*------------------------------ public variables ----------------------------*/

extern CHR_type Main_Buffer[];

extern SYM_type Main_Anonymous;
extern SYM_type Main_Begin;
extern SYM_type Main_Define;
extern FLS_type Grammar_False;
extern SYM_type Main_If;
extern SYM_type Main_Lambda;
extern SYM_type Main_Protect;
extern SYM_type Main_Quote;
extern SYM_type Main_Set;
extern SYM_type Main_Spawn;
extern SYM_type Main_While;

/*------------------------------ hidden prototypes ---------------------------*/

NIL_type              _Main_Register(ERF_type);

/*------------------------------ public prototypes ---------------------------*/

NIL_type    Main_Adjust_Global_Frame(NIL_type);
EXP_type                  Main_Error(BYT_type);
EXP_type        Main_Error_Procedure(BYT_type,
                                     PRC_type);
EXP_type Main_Error_Procedure_Vararg(BYT_type,
                                     PRC_type);
EXP_type           Main_Error_Symbol(BYT_type,
                                     SYM_type);
EXP_type              Main_Error_Tag(BYT_type,
                                     TAG_type);
EXP_type             Main_Error_Text(BYT_type,
                                     TXT_type);
NIL_type                   Main_Exit(NIL_type);
NIL_type                   Main_Fail(BYT_type);
VEC_type    Main_Initialize_Vector_M(UNS_type);
NIL_type            Main_Lock_Thread(LCK_type);
LCK_type            Main_Make_Lock_M(NIL_type);
NIL_type                  Main_Print(TXT_type);
TXT_type                   Main_Read(TXT_type);
NIL_type              Main_Reclaim_C(NIL_type);
NIL_type    Main_Reallocate_Vector_M(VRF_type,
                                     UNS_type);
NIL_type                Main_Replace(FRM_type, 
                                     FRM_type);
PAI_type                Main_Reverse(PAI_type);
NIL_type              Main_Terminate(NIL_type);
NIL_type          Main_Unlock_Thread(LCK_type);