                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*               memory              */
                     /*-----------------------------------*/


#include "SlipSlip.h"

/*------------------------------ public constants ----------------------------*/

enum { Memory_Cell_Bias         = 0x00000004,
       Memory_Immediate_Maximum = 0x3FFFFFFF,
       Memory_Void_Value        = 0x00000000 };

/*-------------------------------- public types ------------------------------*/

typedef           void * ADR_type;
typedef short unsigned   BYT_type;
typedef       unsigned   CEL_type;
typedef           char   CHR_type;
typedef         double   FLO_type;
typedef         signed   SGN_type;
typedef           void   NIL_type;
typedef       unsigned * REF_type;
typedef           char * TXT_type;
typedef       unsigned   UNS_type;

typedef      union PTR * PTR_type;  /* opaque */

/*------------------------------ public callbacks ----------------------------*/

NIL_type  Memory_After_Reclaim(PTR_type);
PTR_type Memory_Before_Reclaim(NIL_type);

/*------------------------------ public prototypes ---------------------------*/

UNS_type      Memory_Available(NIL_type);
NIL_type        Memory_Collect(NIL_type);
SGN_type  Memory_Get_Immediate(PTR_type);
UNS_type       Memory_Get_Size(PTR_type);
BYT_type        Memory_Get_Tag(PTR_type);
BYT_type   Memory_Is_Immediate(PTR_type);
PTR_type     Memory_Make_Chunk(BYT_type,
                               UNS_type);
PTR_type Memory_Make_Immediate(SGN_type);
NIL_type        Memory_Replace(PTR_type,
                               PTR_type);
NIL_type        Memory_Set_Tag(PTR_type,
                               BYT_type);
                                       
/*----------------------------------------------------------------------------*/
                               
NIL_type     Memory_Initialize(ADR_type,
                               UNS_type);