                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*               pool                */
                     /*-----------------------------------*/

#include <string.h>

#include "SlipMain.h"

#include "SlipPool.h"

/*------------------------------ private constants ---------------------------*/

enum {   Initial_pool_size = 128,
       Pool_size_increment =  32 };

/*------------------------------ private variables ---------------------------*/

static VEC_type Pool_vector;
static UNS_type Top_of_pool;

/*------------------------------ public functions ----------------------------*/

SYM_type Pool_Enter_C(TXT_type Text)
  { SYM_type symbol;
    TXT_type text;
    UNS_type index,
             size;
    for (index = 1;
         index < Top_of_pool;
         index++)
      { symbol = Pool_vector[index];
        text = symbol->txt;
        if (strcmp(Text,
                   text) == 0)
          return symbol; }
    size = size_VEC(Pool_vector);
    if (Top_of_pool == size)
      { size += Pool_size_increment;
        Main_Claim_Dynamic(size);
        Main_Reallocate_Vector_M(&Pool_vector,
                                 Pool_size_increment);
        Main_Release_Dynamic(size); }
    size = size_SYM(Text);
    Main_Claim_Dynamic(size);
    symbol = make_SYM_M(Text);
    Main_Release_Dynamic(size);
    Pool_vector[Top_of_pool++] = symbol;
    return symbol; }

SYM_type Pool_Enter_M(TXT_type Text)
  { SYM_type symbol;
    symbol = make_SYM_M(Text);
    Pool_vector[Top_of_pool++] = symbol;
    return symbol; }
    
/*----------------------------------------------------------------------------*/
                               
NIL_type Pool_Initialize_M(NIL_type)
  { Top_of_pool = 1;
    Pool_vector = Main_Initialize_Vector_M(Initial_pool_size);
    Main_Register(Pool_vector); }