                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*               stack               */
                     /*-----------------------------------*/

#include "SlipMain.h"

#include "SlipStack.h"

/*------------------------------ private constants ---------------------------*/

enum {   Initial_stack_size = 64,
       Stack_size_increment = 32 };

/*------------------------------ private variables ---------------------------*/

static VEC_type Stack_vector;
static UNS_type Top_of_stack;

/*------------------------------ public functions ----------------------------*/

NIL_type Stack_Empty(NIL_type)
  { Top_of_stack = 0; }

EXP_type Stack_Peek(NIL_type)
  { return Stack_vector[Top_of_stack]; }

NIL_type Stack_Poke(EXP_type Expression)
  { Stack_vector[Top_of_stack] = Expression; }

EXP_type Stack_Pop(NIL_type)
  { EXP_type expression;
    expression = Stack_vector[Top_of_stack];
    Stack_vector[Top_of_stack--] = Grammar_Null;
    return expression; }

EXP_type Stack_Push_C(EXP_type Expression)
  { UNS_type index,
             size;
    VEC_type vector;
    size = size_VEC(Stack_vector);
    Stack_vector[++Top_of_stack] = Expression;
    if (Top_of_stack == size)
      { size += Stack_size_increment;
        Main_Claim_Dynamic(size);
        vector = make_VEC_M(size);
        Main_Release_Dynamic(size);
        for (index = 1;
             index <= Top_of_stack;
             index++)
          vector[index] = Stack_vector[index];
        for (index = Top_of_stack + 1;
             index <= size;
             index++)
          vector[index] = Grammar_Null;
        Stack_vector = vector;
        return Stack_vector[Top_of_stack]; }
    return Expression; }

EXP_type Stack_Reduce(NIL_type)
  { EXP_type expression,
             result;
    expression = Stack_vector[Top_of_stack--];
    result = Stack_vector[Top_of_stack];
    Stack_vector[Top_of_stack] = expression;
    return result; }

NIL_type Stack_Reset(NIL_type)
  { UNS_type index;
    for (index = 1;
         index <= Top_of_stack;
         index++)
      Stack_vector[index] = Grammar_Null;
    Top_of_stack = 0; }

NIL_type Stack_Zap(NIL_type)
  { Top_of_stack--; }

/*----------------------------------------------------------------------------*/
                               
NIL_type Stack_Initialize_M(NIL_type)
  { Top_of_stack = 0;
    Stack_vector = Main_Initialize_Vector_M(Initial_stack_size);
    Main_Register(Stack_vector); }