                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*               test                */
                     /*-----------------------------------*/

#include <stdio.h>
#include <stdlib.h>

#include "SlipSlip.h"

#define AL1_error_string "at least one argument required"
#define AL2_error_string "at least two arguments required"
#define ALO_error_string "at least one expression required"
#define AM1_error_string "at most one argument required"
#define AM2_error_string "at most two arguments required"
#define ARN_error_string "arguments restricted to numbers"
#define BFO_error_string "buffer overflow"
#define BRQ_error_string "boolean value required"
#define CRQ_error_string "continuation requires single value"
#define DRQ_error_string "digit required"
#define E1X_error_string "exactly one expression required"
#define EX0_error_string "no arguments allowed"
#define EX1_error_string "exactly one argument required"
#define EX2_error_string "exactly two arguments required"
#define EX3_error_string "exactly three arguments required"
#define ICL_error_string "invalid character literal"
#define ILC_error_string "illegal character"
#define ILH_error_string "illegal use of #"
#define IMC_error_string "insufficient memory claim"
#define IMM_error_string "insufficient memory"
#define IOR_error_string "index out of range"
#define IPA_error_string "invalid parameter"
#define IRB_error_string "illegal right bracket"
#define IRP_error_string "illegal right parenthesis"
#define ITA_error_string "improperly terminated argument list"
#define ITF_error_string "improperly terminated form"
#define IUP_error_string "illegal use of period"
#define IVP_error_string "invalid pattern in form"
#define IVV_error_string "missing variable in form"
#define IXT_error_string "invalid expression type"
#define MRP_error_string "missing right parenthesis"
#define MSP_error_string "missing pattern in form"
#define MSV_error_string "invalid variable in form"
#define NAB_error_string "not a boolean"
#define NAL_error_string "not a list"
#define NAN_error_string "not a number"
#define NAP_error_string "not a pair"
#define NAS_error_string "not a string"
#define NAV_error_string "not a vector"
#define NNN_error_string "non-negative number required"
#define NTL_error_string "number too large"
#define NTO_error_string "native table overflow"
#define OPR_error_string "operator required"
#define PEP_error_string "premature end of program"
#define QRQ_error_string "quote required"
#define TFO_error_string "too few operands in application"
#define TFX_error_string "too few expressions in form"
#define TMO_error_string "too many operands in application"
#define TMR_error_string "too many root registrations"
#define TMT_error_string "too many thread registrations"
#define TMX_error_string "too many expressions in form"
#define TPO_error_string "thread pool overflow"
#define VNF_error_string "variable not found"
#define XCT_error_string "excess tokens"
#define PT1_error_string "pthread EAGAIN error"
#define PT2_error_string "pthread EBUSY error"
#define PT3_error_string "pthread EINVAL error"
#define PT4_error_string "pthread EDEADLK error"
#define PT5_error_string "pthread ENOMEM error"
#define PT6_error_string "pthread EPERM error"
#define PT7_error_string "pthread ESRCH error"
#define PT8_error_string "pthread ETIMEDOUT error"
#define PT9_error_string "pthread other error"

const static char* errors[] =
     { AL1_error_string,
       AL2_error_string,
       ALO_error_string,
       AM1_error_string,
       AM2_error_string,
       ARN_error_string,
       BFO_error_string,
       BRQ_error_string,
       CRQ_error_string,
       DRQ_error_string,
       E1X_error_string,
       EX0_error_string,
       EX1_error_string,
       EX2_error_string,
       EX3_error_string,
       ICL_error_string,
       ILC_error_string,
       ILH_error_string,
       IMC_error_string,
       IMM_error_string,
       IOR_error_string,
       IPA_error_string,
       IRB_error_string,
       IRP_error_string,
       ITA_error_string,
       ITF_error_string,
       IUP_error_string,
       IVP_error_string,
       IVV_error_string,
       IXT_error_string,
       MRP_error_string,
       MSP_error_string,
       MSV_error_string,
       NAB_error_string,
       NAL_error_string,
       NAN_error_string,
       NAP_error_string,
       NAS_error_string,
       NAV_error_string,
       NNN_error_string,
       NTL_error_string,
       NTO_error_string,
       OPR_error_string,
       PEP_error_string,
       QRQ_error_string,
       TFO_error_string,
       TFX_error_string,
       TMO_error_string,
       TMR_error_string,
       TMT_error_string,
       TMX_error_string,
       TPO_error_string,
       VNF_error_string,
       XCT_error_string,
       PT1_error_string,
       PT2_error_string,
       PT3_error_string,
       PT4_error_string,
       PT5_error_string,
       PT6_error_string,
       PT7_error_string,
       PT8_error_string,
       PT9_error_string };

enum { Buffer_size = 10000,
       Memory_size = 10000000 };

static char Buffer[Buffer_size];
static char Memory[Memory_size];

static int counter = 0;

void  Slip_Error(short error,
                 char* message)
  { if (message == 0)
      printf("\nerror: %s\n", errors[error]);
    else
      printf("\nerror: %s : %s\n", errors[error] , message); }
  
void Slip_Fail(short error)
  { printf("\nfatal error: %s\n", errors[error]);
    exit(0); }

void Slip_Log(char* message)
  { printf("\n%d>>> %s\n", counter++, message); }

char* Slip_Load(char* text)
  { FILE * stream = fopen(text, "r");
    Buffer[0] = 0;
    if (stream)
      { unsigned index;
        char character;
        printf("\a");
        for (index = 0;;)
          { int result = fscanf(stream, "%c", &character);
            if (result == EOF)
              { Buffer[index] = 0;
                fclose(stream);
                return Buffer; }
            else
              Buffer[index++] = character; }}
    printf("%s not found\n", text);
    return Buffer; }

void Slip_Print(char* string)
  { printf("%s", string); }

char* Slip_Read(void)
  { unsigned index;
    char character;
    for (index = 0;;)
      { scanf("%c", &character);
        if (character == '\n')
          { Buffer[index] = 0;
            return Buffer; }
        Buffer[index++] = character; }}

int main (int argc, const char * argv[])
  { Slip_REP(Memory, Memory_size);
    return 0; }